//x128
//http://forum.vingrad.ru/forum/topic-305345/anchor-entry2184320/15.html# 
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, XPMan, ExtCtrls, ComCtrls, PNGImage, Menus;

type
  TMyTrackBar = class(TTrackBar)
    property OnMouseUp;
  end;
  TForm1 = class(TForm)
    Panel1: TPanel;
    XPManifest1: TXPManifest;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    GroupBox1: TGroupBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MyTrackBar: TMyTrackBar;
    procedure TrackBarChange(Sender: TObject);
    procedure TrackBarMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RemoveTransparentPixels;
  end;

var
  Form1: TForm1;
  ncol: integer;
  PNG,TMP: TPNGObject;

implementation

{$R *.dfm}

procedure TForm1.RemoveTransparentPixels;
var
  x,y: integer;
  ImageSRC: pRGBLine;
  AlphaSRC: pByteArray;
begin
  tmp.Assign(png);
  for y:=0 to tmp.Height-1 do begin
    ImageSRC:=tmp.Scanline[y];
    AlphaSRC:=tmp.AlphaScanline[y];
    for x:=0 to tmp.Width-1 do begin
      if AlphaSRC[x]<MyTrackBar.Position then begin
        ImageSRC[x].rgbtBlue:=0;
        ImageSRC[x].rgbtGreen:=0;
        ImageSRC[x].rgbtRed:=0;
      end;
    end;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  if SavePictureDialog1.Execute then begin
    tmp.CompressionLevel:=9;
    tmp.SaveToFile(SavePictureDialog1.FileName);
  end;
end;

procedure TForm1.TrackBarChange(Sender: TObject);
begin
  if PNG.Empty then exit;
  GroupBox1.Caption:=' - '+IntToStr(MyTrackBar.Position);
  RemoveTransparentPixels;
  tmp.RemoveTransparency;
  image1.Picture.Assign(tmp);
end;

procedure TForm1.TrackBarMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer);
begin
  if PNG.Empty then exit;
  RemoveTransparentPixels;
  image1.Picture.Assign(tmp);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyTrackBar:=TMyTrackBar.Create(self);
  with MyTrackBar do begin
    Parent:=GroupBox1;
    Align:=alClient;
    Min:=0;
    Max:=255;
    Position:=0;
    //PositionToolTip:=ptTop;
    ShowSelRange:=false;
    ThumbLength:=20;
    TickStyle:=tsNone;
    OnChange:=TrackBarChange;
    OnMouseUp:=TrackBarMouseUp;
  end;
  PNG:=TPNGObject.Create;
  TMP:=TPNGObject.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  PNG.Destroy;
  TMP.Destroy;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then begin
    if PNG=nil then PNG:=TPNGObject.Create;
    png.LoadFromFile(OpenPictureDialog1.FileName);
    image1.Height:=png.Height;
    image1.Width:=png.Width;
    RemoveTransparentPixels;
    image1.Picture.Assign(tmp);
  end;
end;

end.
